AVR_CC = avr-gcc
AVR_OBJCOPY = avr-objcopy

LIBAVR_SRCS = ${LIBAVR}/libavr/*.c

CFLAGS_ALL ?= ${CFLAGS}

CFLAGS_AVR = ${CFLAGS_ALL} -I${LIBAVR} -ffreestanding \
	-funsigned-char -funsigned-bitfields -fpack-struct -fshort-enums \
	-ffunction-sections -finline-limit=5 --combine -fwhole-program \
        ${LIBAVR}/crt/crt-hack.c
LDFLAGS_AVR = -I${LIBAVR} -Wl,--gc-sections,--relax -nostartfiles \
	${LIBAVR}/crt/crt-weak.S

###

.SUFFIXES: .bin .elf .hex
%.bin:%.elf
	${AVR_OBJCOPY} -O binary -R .eeprom $< $@
%.hex:%.elf
	${AVR_OBJCOPY} -O ihex -R .eeprom $< $@

####

define AVR_COMPILE
	${AVR_CC} -mmcu=$1 ${CFLAGS_AVR} $2 -S -o $@.S $^
	${AVR_CC} -mmcu=$1 ${LDFLAGS_AVR} $3 -o $@ $@.S
	rm -f $@.S
endef
