#ifndef __LIBAVR_DELAY__
#define __LIBAVR_DELAY__

#define delay_us(x) delay_cycles(((long)x) * (F_CPU / 1000000UL))
#define delay_ms(x) delay_cycles(((long)x) * (F_CPU / 1000UL))
#define delay_us2(x) delay_cycles2(((long)x) * (F_CPU / 1000000UL))
#define delay_ms2(x) delay_cycles2(((long)x) * (F_CPU / 1000UL))

/* delay_cycles(x) takes 6+8*floor(x/8) cycles */
#define delay_cycles(x) \
    asm volatile ( "ldi r30, %1\n\t" \
                   "ldi r31, %2\n\t" \
                   "mov r0, r30\n\t" \
                   "mov r1, r31\n\t" \
                   "clr r30\n\t" \
                   "ldi r31, %0\n\t" \
                   "1: subi r31, 1\n\t" \
                   "sbc r0, r30\n\t" \
                   "sbc r1, r30\n\t" \
                   "breq 3f\n\t" \
                   "rjmp 2f\n\t" \
                   "2: rjmp 1b\n\t" \
                   "3:" \
                   : \
                   : "i" ((x >> 3) & 0xff), \
                     "i" ((x >> 11) & 0xff), \
                     "i" ((x >> 19) & 0xff) \
                   : "r0", "r1", "r30", "r31")

/* delay_cycles2(x) takes 2+4*floor(x/4) cycles */
#define delay_cycles2(x) \
    asm volatile ( "ldi r30, %0\n\t" \
                   "ldi r31, %1\n\t" \
                   "1: sbiw r30, 1\n\t" \
                   "brne 1b\n\t" \
                   : \
                   : "i" ((x >> 2) & 0xff), \
                     "i" ((x >> 10) & 0xff) \
                   : "r30", "r31")

#endif
