#ifndef __LIBAVR_DEVICE__
#define __LIBAVR_DEVICE__

#include <stdint.h>

/* when using __IO_MEM(address),
 * address is suitable for use in lds/sts instructions
 */
#define __IO_MEM(address) (*(volatile uint8_t *)(address))
#define __IO_MEM16(address) (*(volatile uint16_t *)(address))

#if defined(__AVR_ATmega8__)
#include <libavr/device/m8.h>
#elif defined(__AVR_ATmega48__) || defined(__AVR_ATmega48A__) || defined(__AVR_ATmega48PA__)
#include <libavr/device/m48.h>
#elif defined(__AVR_ATmega88__) || defined(__AVR_ATmega88A__) || defined(__AVR_ATmega88PA__)
#include <libavr/device/m88.h>
#elif defined(__AVR_ATmega128__)
#include <libavr/device/m128.h>
#elif defined(__AVR_ATmega164P__) || defined(__AVR_ATmega164A__) || defined(__AVR_ATmega164PA__)
#include <libavr/device/m164.h>
#elif defined(__AVR_ATmega168__) || defined(__AVR_ATmega168A__) || defined(__AVR_ATmega168PA__)
#include <libavr/device/m168.h>
#elif defined(__AVR_ATmega324P__) || defined(__AVR_ATmega324A__) || defined(__AVR_ATmega324PA__)
#include <libavr/device/m324.h>
#elif defined(__AVR_ATmega328__) || defined(__AVR_ATmega328P__)
#include <libavr/device/m328.h>
#elif defined(__AVR_ATmega644P__) || defined(__AVR_ATmega644A__) || defined(__AVR_ATmega644PA__)
#include <libavr/device/m644.h>
#elif defined(__AVR_ATmega1284__) || defined(__AVR_ATmega128P__)
#include <libavr/device/m1284.h>
#else
#warning "device not known"
#endif

#endif
