#include <libavr/bits.h>
#include <libavr/flash_write.h>

#define noinline __attribute__((noinline))

noinline void flash_wait(void) {
    while (bit_is_set(SPMCR, SPMEN))
        /* nothing */ ;
}

void flash_erase(faddr_t page) {
    flash_wait();
    flash_page_erase(page);
}

void flash_write(faddr_t page, void *buf) {
    unsigned int *w = buf;
    int i;

    for (i = 0; i < SPM_PAGESIZE/2; i++) {
        flash_wait();
        flash_page_fill(page + i*2, w[i]);
    }
    flash_wait();
    flash_page_write(page);
}
