#ifndef __LIBAVR_INTERRUPT__
#define __LIBAVR_INTERRUPT__

#ifdef NOINTERRUPTS
#define WHEN_INTERRUPTS_ENABLED(x)

#else
#define WHEN_INTERRUPTS_ENABLED(x) x

#define __SIGNAL__(name, attributes) \
    void name (void) __attribute__ (attributes); \
    void name (void)

#define cli()              asm volatile ( "cli" );
#define sei()              asm volatile ( "sei" );
#define reti()             asm volatile ( "reti" );
#define SIGNAL(v)          __SIGNAL__(__vector_##v, (signal, used))
#define SIGNAL_NONBLOCK(v) __SIGNAL__(__vector_##v, (signal, used, interrupt))
#define SIGNAL_NAKED(v)    __SIGNAL__(__vector_##v, (signal, used, naked))
#endif


#define INTERRUPTS_OFF(r) \
    WHEN_INTERRUPTS_ENABLED( \
        "in " r ", __SREG__\n\t" \
        "cli\n\t" )
#define INTERRUPTS_RESTORE(r) \
    WHEN_INTERRUPTS_ENABLED( \
        "out __SREG__, " r "\n\t" )

#endif
